## lxd 2.12

=== Makefile ===
DOMAIN=lxd
POFILES=$(wildcard po/*.po)
MOFILES=$(patsubst %.po,%.mo,$(POFILES))
LINGUAS=$(basename $(POFILES))
POTFILE=po/$(DOMAIN).pot

# dist is primarily for use when packaging; for development we still manage
# dependencies via `go get` explicitly.
# TODO: use git describe for versioning
VERSION=$(shell grep "var Version" shared/version/flex.go | cut -d'"' -f2)
ARCHIVE=lxd-$(VERSION).tar
TAGS=$(shell test -e /usr/include/sqlite3.h && echo "-tags libsqlite3")

.PHONY: default
default:
	go get -t -v -d ./...
	go install -v $(TAGS) $(DEBUG) ./...
	@echo "LXD built successfully"

.PHONY: client
client:
	go get -t -v -d ./...
	go install -v $(TAGS) $(DEBUG) ./lxc
	@echo "LXD client built successfully"

.PHONY: update
update:
	go get -t -v -d -u ./...
	@echo "Dependencies updated"

# This only needs to be done when migrate.proto is actually changed; since we
# commit the .pb.go in the tree and it's not expected to change very often,
# it's not a default build step.
.PHONY: protobuf
protobuf:
	protoc --go_out=. ./lxd/migrate.proto

.PHONY: check
check: default
	go get -v -x github.com/rogpeppe/godeps
	go get -v -x github.com/remyoudompheng/go-misc/deadcode
	go get -v -x github.com/golang/lint/golint
	go test -v $(TAGS) $(DEBUG) ./...
	cd test && ./main.sh

gccgo:
	go build -v $(TAGS) $(DEBUG) -compiler gccgo ./...
	@echo "LXD built successfully with gccgo"

.PHONY: dist
dist:
	# Cleanup
	rm -Rf $(ARCHIVE).gz
	
	# Create build dir
	$(eval TMP := $(shell mktemp -d))
	git archive --prefix=lxd-$(VERSION)/ HEAD | tar -x -C $(TMP)
	mkdir -p $(TMP)/dist/src/github.com/lxc
	ln -s ../../../../lxd-$(VERSION) $(TMP)/dist/src/github.com/lxc/lxd
	
	# Download dependencies
	cd $(TMP)/lxd-$(VERSION) && GOPATH=$(TMP)/dist go get -t -v -d ./...
	
	# Workaround for gorilla/mux on Go < 1.7
	cd $(TMP)/lxd-$(VERSION) && GOPATH=$(TMP)/dist go get -v -d github.com/gorilla/context
	
	# Assemble tarball
	rm $(TMP)/dist/src/github.com/lxc/lxd
	ln -s ../../../../ $(TMP)/dist/src/github.com/lxc/lxd
	mv $(TMP)/dist $(TMP)/lxd-$(VERSION)/
	tar --exclude-vcs -C $(TMP) -zcf $(ARCHIVE).gz lxd-$(VERSION)/
	
	# Cleanup
	rm -Rf $(TMP)

.PHONY: i18n update-po update-pot build-mo static-analysis
i18n: update-pot

po/%.mo: po/%.po
	msgfmt --statistics -o $@ $<

po/%.po: po/$(DOMAIN).pot
	msgmerge -U po/$*.po po/$(DOMAIN).pot

update-po:
	for lang in $(LINGUAS); do\
	    msgmerge -U $$lang.po po/$(DOMAIN).pot; \
	    rm -f $$lang.po~; \
	done

update-pot:
	go get -v -x github.com/snapcore/snapd/i18n/xgettext-go/
	xgettext-go -o po/$(DOMAIN).pot --add-comments-tag=TRANSLATORS: --sort-output --package-name=$(DOMAIN) --msgid-bugs-address=lxc-devel@lists.linuxcontainers.org --keyword=i18n.G --keyword-plural=i18n.NG *.go shared/*.go lxc/*.go lxd/*.go

build-mo: $(MOFILES)

static-analysis:
	/bin/bash -x -c ". test/static_analysis.sh; static_analysis"

tags: *.go lxd/*.go shared/*.go lxc/*.go
	find . | grep \.go | grep -v git | grep -v .swp | grep -v vagrant | xargs gotags > tags

=== debian/control ===
Source: lxd
Section: admin
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
Standards-Version: 3.9.8
Homepage: https://linuxcontainers.org/
Vcs-Git: https://github.com/lxc/lxd-pkg-ubuntu
Vcs-Browser: https://github.com/lxc/lxd-pkg-ubuntu
Build-Depends: debhelper (>= 9),
               dh-apparmor,
               dh-golang,
               dh-systemd,
               golang-go,
               golang-any-shared-dev,
               golang-go.crypto-dev,
               golang-github-gorilla-mux-dev,
               golang-github-gosexy-gettext-dev,
               golang-github-mattn-go-colorable-dev,
               golang-github-mattn-go-sqlite3-dev,
               golang-github-olekukonko-tablewriter-dev,
               golang-github-pborman-uuid-dev,
               golang-gocapability-dev,
               golang-gopkg-flosch-pongo2.v3-dev,
               golang-gopkg-inconshreveable-log15.v2-dev,
               golang-gopkg-lxc-go-lxc.v2-dev,
               golang-gopkg-tomb.v2-dev,
               golang-goprotobuf-dev,
               golang-petname-dev,
               golang-yaml.v2-dev,
               golang-websocket-dev,
               help2man,
               libsqlite3-dev,
               lxc-dev (>= 1.1.0~),
               pkg-config,
               python3-lxc

Package: lxd-client
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Built-Using: ${misc:Built-Using}
Suggests: lxd
Breaks: lxc1 (<= 2.0.0~rc13-0ubuntu2~)
Replaces: lxc1 (<= 2.0.0~rc13-0ubuntu2~)
Description: Container hypervisor based on LXC - client
 LXD offers a REST API to remotely manage containers over the network,
 using an image based workflow and with support for live migration.
 .
 This package contains the command line client.

Package: lxd
Architecture: any
Depends: acl,
         adduser,
         dnsmasq-base,
         ebtables,
         iptables,
         liblxc1 (>= 2.0.0~),
         lsb-base (>= 3.0-6),
         lxd-client (= ${binary:Version}),
         lxcfs,
         passwd (>= 1:4.1.5.1-1ubuntu5~),
         rsync,
         squashfs-tools,
         uidmap (>= 1:4.1.5.1-1ubuntu5~),
         xz-utils,
         ${misc:Depends},
         ${shlibs:Depends}
Built-Using: ${misc:Built-Using}
Suggests: criu, lxd-tools
Description: Container hypervisor based on LXC - daemon
 LXD offers a REST API to remotely manage containers over the network,
 using an image based workflow and with support for live migration.
 .
 This package contains the LXD daemon.

Package: lxc2
Architecture: all
Depends: lxd, lxd-client, ${misc:Depends}
Priority: extra
Section: metapackages
Description: Container hypervisor based on LXC - metapackage
 LXD offers a REST API to remotely manage containers over the network,
 using an image based workflow and with support for live migration.
 .
 This is a dummy metapackage to install LXD and its client.

Package: lxd-tools
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, python3, python3-lxc
Built-Using: ${misc:Built-Using}
Description: Container hypervisor based on LXC - extra tools
 LXD offers a REST API to remotely manage containers over the network,
 using an image based workflow and with support for live migration.
 .
 This package contains extra tools provided with LXD.
  - fuidshift - A tool to map/unmap filesystem uids/gids
  - lxc-to-lxd - A tool to migrate LXC containers to LXD
  - lxd-benchmark - A benchmarking tool for LXD

Package: golang-github-lxc-lxd-dev
Architecture: all
Depends: golang-go, lxc-dev, pkg-config, ${misc:Depends}, ${shlibs:Depends}
Description: Container hypervisor based on LXC - go source
 LXD offers a REST API to remotely manage containers over the network,
 using an image based workflow and with support for live migration.
 .
 This package contains the source tree of the lxd project.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

PKGDIR=debian/tmp
VERSION=$(shell grep "var Version" $(CURDIR)/shared/version/flex.go | cut -d'"' -f2)
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

# temporary build path (see http://golang.org/doc/code.html#GOPATH)
export DH_GOPKG := github.com/lxc/lxd
export GOPATH := $(CURDIR)/obj-$(DEB_BUILD_GNU_TYPE)
export USE_EMBEDDED := false
export USE_SHLIBS := true

ifeq ($(USE_SHLIBS), true)
export DH_GOLANG_LINK_SHARED := 1
endif

%:
	dh $@ --with systemd --buildsystem=golang --with=golang

# Make sure we use the distro libsqlite3
override_dh_auto_build:
	dh_auto_build -- -tags libsqlite3

# Ugly workaround for bundled dependencies
override_dh_auto_configure:
	dh_auto_configure

	# dh-golang's configure has copied the source tree into GOPATH. But
	# because lxd gets some dependencies from the archive and some from
	# the copies bundled in dist, we have to unpick a bunch of what it has
	# done and set it up again.

	# Remove the extra copy of dist dh-golang has copied onto GOPATH (or
	# when dh-golang tries to run go install github.com/lxc/lxd/... things
	# get very confused).
	rm -Rf ${GOPATH}/src/github.com/lxc/lxd/dist

	# Move the lxd source aside while we do this.
	mv ${GOPATH}/src/github.com/lxc/lxd ${GOPATH}/lxd.tmp

	# Clean GOPATH.
ifeq ($(USE_SHLIBS), true)
	rm -Rf ${GOPATH}/src/srclibs
else
	rm -Rf ${GOPATH}/src
endif

ifeq ($(USE_EMBEDDED), true)
	# If we get all dependencies from dist, just copy it onto GOPATH.
	cp -R dist/src ${GOPATH}

	# But not the symlink for lxd.
	rm -f ${GOPATH}/src/github.com/lxc/lxd
else
	# If not, link depedencies from dist or from where the distro package
	# has installed it, as appropriate.

	# Packaged dependencies
	debian/helpers/link-from-installed github.com/dustinkirkland/golang-petname
	debian/helpers/link-from-installed github.com/golang/protobuf
	debian/helpers/link-from-installed github.com/gorilla/mux
	debian/helpers/link-from-installed github.com/gorilla/websocket
	debian/helpers/link-from-installed github.com/gosexy/gettext
	debian/helpers/link-from-installed github.com/mattn/go-colorable
	debian/helpers/link-from-installed github.com/mattn/go-sqlite3
	debian/helpers/link-from-installed github.com/olekukonko/tablewriter
	debian/helpers/link-from-installed github.com/pborman/uuid
	debian/helpers/link-from-installed github.com/syndtr/gocapability
	debian/helpers/link-from-installed golang.org/x/crypto
	debian/helpers/link-from-installed gopkg.in/flosch/pongo2.v3
	debian/helpers/link-from-installed gopkg.in/inconshreveable/log15.v2
	debian/helpers/link-from-installed gopkg.in/lxc/go-lxc.v2
	debian/helpers/link-from-installed gopkg.in/tomb.v2
	debian/helpers/link-from-installed gopkg.in/yaml.v2
endif

	# And put the lxd source back again.
	mkdir -p ${GOPATH}/src/github.com/lxc/
	mv ${GOPATH}/lxd.tmp ${GOPATH}/src/github.com/lxc/lxd

override_dh_install:
	# Install lxc-to-lxd
	cp scripts/lxc-to-lxd $(PKGDIR)/usr/bin/lxc-to-lxd

	# Install the manpages
	mkdir -p $(PKGDIR)/usr/share/man/man1/
	help2man $(PKGDIR)/usr/bin/fuidshift -n "uid/gid shifter" --no-info > $(PKGDIR)/usr/share/man/man1/fuidshift.1
	help2man $(PKGDIR)/usr/bin/lxc-to-lxd -n "Convert LXC containers to LXD" --no-info --version-string=$(VERSION) > $(PKGDIR)/usr/share/man/man1/lxc-to-lxd.1
	help2man $(PKGDIR)/usr/bin/lxd -n "The container lightervisor - daemon" --no-info > $(PKGDIR)/usr/share/man/man1/lxd.1
	help2man $(PKGDIR)/usr/bin/lxd-benchmark -n "The container lightervisor - benchmark" --no-info --version-string=$(VERSION) --no-discard-stderr > $(PKGDIR)/usr/share/man/man1/lxd-benchmark.1
	$(PKGDIR)/usr/bin/lxc manpage $(PKGDIR)/usr/share/man/man1/

	# Install bash completion scripts
	mkdir -p $(PKGDIR)/usr/share/bash-completion/completions/
	cp config/bash/lxd-client $(PKGDIR)/usr/share/bash-completion/completions/lxc

	# Prepare dev package
	rm -Rf $(PKGDIR)/usr/share/gocode/src/github.com/lxc/
	mkdir -p $(PKGDIR)/usr/share/gocode/src/github.com/lxc/
	cp -RL ${GOPATH}/src/github.com/lxc/lxd $(PKGDIR)/usr/share/gocode/src/github.com/lxc/
	rm -Rf $(PKGDIR)/usr/share/gocode/src/github.com/lxc/lxd/dist

	# Copy dnsmasq configuration
	mkdir -p $(PKGDIR)/etc/dnsmasq.d-available
	cp debian/lxd.dnsmasq $(PKGDIR)/etc/dnsmasq.d-available/lxd

	# Setup logrotate
	mkdir -p $(PKGDIR)/etc/logrotate.d
	cp debian/lxd.logrotate $(PKGDIR)/etc/logrotate.d/lxd

	# Setup sysctl
	mkdir -p $(PKGDIR)/etc/sysctl.d
	cp debian/lxd.sysctl $(PKGDIR)/etc/sysctl.d/10-lxd-inotify.conf

	# Trigger normal dh_install
	dh_install

override_dh_installinit:
	# We handle starting and restarting things ourselves
	dh_systemd_enable -plxd --name=lxd-containers lxd-containers.service
	dh_installinit -plxd --no-start
	dh_installinit -plxd --name=lxd-containers --no-start --noscripts
	dh_systemd_start -plxd lxd-containers.service --no-restart-on-upgrade

	# Update arch-specific paths
	sed -i "s#@LIBEXECDIR@#/usr/lib/${DEB_HOST_MULTIARCH}#g" debian/lxd/lib/systemd/system/lxd.service
	sed -i "s#@LIBEXECDIR@#/usr/lib/${DEB_HOST_MULTIARCH}#g" debian/lxd/etc/init/lxd.conf
	sed -i "s#@LIBEXECDIR@#/usr/lib/${DEB_HOST_MULTIARCH}#g" debian/lxd/etc/init.d/lxd

override_dh_systemd_start:
	echo "Not running dh_systemd_start"

override_dh_auto_test:
	echo "The testsuite requires privileges and so is run through autopkgtest"

## lxd 2.15

=== Makefile ===
--- 
+++ 
@@ -28,6 +28,12 @@
 	go get -t -v -d -u ./...
 	@echo "Dependencies updated"
 
+.PHONY: debug
+debug:
+	go get -t -v -d ./...
+	go install -v $(TAGS) -tags logdebug $(DEBUG) ./...
+	@echo "LXD built successfully"
+
 # This only needs to be done when migrate.proto is actually changed; since we
 # commit the .pb.go in the tree and it's not expected to change very often,
 # it's not a default build step.
@@ -51,30 +57,30 @@
 dist:
 	# Cleanup
 	rm -Rf $(ARCHIVE).gz
-	
+
 	# Create build dir
 	$(eval TMP := $(shell mktemp -d))
 	git archive --prefix=lxd-$(VERSION)/ HEAD | tar -x -C $(TMP)
 	mkdir -p $(TMP)/dist/src/github.com/lxc
 	ln -s ../../../../lxd-$(VERSION) $(TMP)/dist/src/github.com/lxc/lxd
-	
+
 	# Download dependencies
 	cd $(TMP)/lxd-$(VERSION) && GOPATH=$(TMP)/dist go get -t -v -d ./...
-	
+
 	# Workaround for gorilla/mux on Go < 1.7
 	cd $(TMP)/lxd-$(VERSION) && GOPATH=$(TMP)/dist go get -v -d github.com/gorilla/context
-	
+
 	# Assemble tarball
 	rm $(TMP)/dist/src/github.com/lxc/lxd
 	ln -s ../../../../ $(TMP)/dist/src/github.com/lxc/lxd
 	mv $(TMP)/dist $(TMP)/lxd-$(VERSION)/
 	tar --exclude-vcs -C $(TMP) -zcf $(ARCHIVE).gz lxd-$(VERSION)/
-	
+
 	# Cleanup
 	rm -Rf $(TMP)
 
 .PHONY: i18n update-po update-pot build-mo static-analysis
-i18n: update-pot
+i18n: update-pot update-po
 
 po/%.mo: po/%.po
 	msgfmt --statistics -o $@ $<
@@ -95,7 +101,7 @@
 build-mo: $(MOFILES)
 
 static-analysis:
-	/bin/bash -x -c ". test/static_analysis.sh; static_analysis"
+	(cd test;  /bin/sh -x -c ". suites/static_analysis.sh; test_static_analysis")
 
 tags: *.go lxd/*.go shared/*.go lxc/*.go
 	find . | grep \.go | grep -v git | grep -v .swp | grep -v vagrant | xargs gotags > tags

=== debian/changelog ===
lxd (2.15-0ubuntu6~ubuntu16.10.1) yakkety-backports; urgency=medium

  * Backport to Xenial.
  * Disable shared libraries.
  * Use embedded dependencies for backport.

 -- Stéphane Graber <stgraber@ubuntu.com>  Thu, 06 Jul 2017 01:00:09 -0400

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: admin
 Priority: optional
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-Standards-Version: 3.9.8
+Standards-Version: 4.0.0
 Homepage: https://linuxcontainers.org/
 Vcs-Git: https://github.com/lxc/lxd-pkg-ubuntu
 Vcs-Browser: https://github.com/lxc/lxd-pkg-ubuntu
@@ -11,23 +11,6 @@
                dh-golang,
                dh-systemd,
                golang-go,
-               golang-any-shared-dev,
-               golang-go.crypto-dev,
-               golang-github-gorilla-mux-dev,
-               golang-github-gosexy-gettext-dev,
-               golang-github-mattn-go-colorable-dev,
-               golang-github-mattn-go-sqlite3-dev,
-               golang-github-olekukonko-tablewriter-dev,
-               golang-github-pborman-uuid-dev,
-               golang-gocapability-dev,
-               golang-gopkg-flosch-pongo2.v3-dev,
-               golang-gopkg-inconshreveable-log15.v2-dev,
-               golang-gopkg-lxc-go-lxc.v2-dev,
-               golang-gopkg-tomb.v2-dev,
-               golang-goprotobuf-dev,
-               golang-petname-dev,
-               golang-yaml.v2-dev,
-               golang-websocket-dev,
                help2man,
                libsqlite3-dev,
                lxc-dev (>= 1.1.0~),

=== debian/rules ===
--- 
+++ 
@@ -11,8 +11,8 @@
 # temporary build path (see http://golang.org/doc/code.html#GOPATH)
 export DH_GOPKG := github.com/lxc/lxd
 export GOPATH := $(CURDIR)/obj-$(DEB_BUILD_GNU_TYPE)
-export USE_EMBEDDED := false
-export USE_SHLIBS := true
+export USE_EMBEDDED := true
+export USE_SHLIBS := false
 
 ifeq ($(USE_SHLIBS), true)
 export DH_GOLANG_LINK_SHARED := 1
@@ -62,6 +62,7 @@
 	# Packaged dependencies
 	debian/helpers/link-from-installed github.com/dustinkirkland/golang-petname
 	debian/helpers/link-from-installed github.com/golang/protobuf
+	debian/helpers/link-from-installed github.com/gorilla/context
 	debian/helpers/link-from-installed github.com/gorilla/mux
 	debian/helpers/link-from-installed github.com/gorilla/websocket
 	debian/helpers/link-from-installed github.com/gosexy/gettext

=== debian/tests/control ===
Tests: exercise
Depends: acl,
         busybox-static,
         btrfs-tools,
         curl,
         golang-go,
         jq,
         git,
         gettext,
         lvm2,
         make,
         pep8,
         pyflakes3,
         shellcheck,
         sqlite3,
         thin-provisioning-tools,
         uuid-runtime,
         zfsutils-linux [amd64 arm64 ppc64el s390x],
         @
Restrictions: needs-root allow-stderr isolation-machine

## lxd 2.18

=== Makefile ===
--- 
+++ 
@@ -27,6 +27,11 @@
 update:
 	go get -t -v -d -u ./...
 	@echo "Dependencies updated"
+
+.PHONY: update
+update-schema:
+	go run -v $(TAGS) ./lxd/schema.go
+	@echo "Schema source code updated"
 
 .PHONY: debug
 debug:
@@ -96,7 +101,7 @@
 
 update-pot:
 	go get -v -x github.com/snapcore/snapd/i18n/xgettext-go/
-	xgettext-go -o po/$(DOMAIN).pot --add-comments-tag=TRANSLATORS: --sort-output --package-name=$(DOMAIN) --msgid-bugs-address=lxc-devel@lists.linuxcontainers.org --keyword=i18n.G --keyword-plural=i18n.NG *.go shared/*.go lxc/*.go lxd/*.go
+	xgettext-go -o po/$(DOMAIN).pot --add-comments-tag=TRANSLATORS: --sort-output --package-name=$(DOMAIN) --msgid-bugs-address=lxc-devel@lists.linuxcontainers.org --keyword=i18n.G --keyword-plural=i18n.NG shared/*.go lxc/*.go lxd/*.go
 
 build-mo: $(MOFILES)

=== debian/control ===
--- 
+++ 
@@ -2,23 +2,42 @@
 Section: admin
 Priority: optional
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-Standards-Version: 4.0.0
+Standards-Version: 4.1.0
 Homepage: https://linuxcontainers.org/
 Vcs-Git: https://github.com/lxc/lxd-pkg-ubuntu
 Vcs-Browser: https://github.com/lxc/lxd-pkg-ubuntu
 Build-Depends: debhelper (>= 9),
                dh-apparmor,
                dh-golang,
-               dh-systemd,
+               debhelper (>= 9.20160709) | dh-systemd,
                golang-go,
+               golang-any-shared-dev,
+               golang-go.crypto-dev,
+               golang-github-gorilla-context-dev,
+               golang-github-gorilla-mux-dev,
+               golang-github-gosexy-gettext-dev,
+               golang-github-mattn-go-colorable-dev,
+               golang-github-mattn-go-sqlite3-dev,
+               golang-github-olekukonko-tablewriter-dev,
+               golang-github-pborman-uuid-dev,
+               golang-gocapability-dev,
+               golang-gopkg-flosch-pongo2.v3-dev,
+               golang-gopkg-inconshreveable-log15.v2-dev,
+               golang-gopkg-lxc-go-lxc.v2-dev,
+               golang-gopkg-tomb.v2-dev,
+               golang-goprotobuf-dev,
+               golang-petname-dev,
+               golang-yaml.v2-dev,
+               golang-websocket-dev,
                help2man,
+               libacl1-dev,
                libsqlite3-dev,
                lxc-dev (>= 1.1.0~),
                pkg-config,
                python3-lxc
 
 Package: lxd-client
-Architecture: any
+Architecture: amd64 arm64 armhf i386 ppc64el s390x
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Built-Using: ${misc:Built-Using}
 Suggests: lxd
@@ -31,13 +50,13 @@
  This package contains the command line client.
 
 Package: lxd
-Architecture: any
+Architecture: amd64 arm64 armhf i386 ppc64el s390x
 Depends: acl,
          adduser,
          dnsmasq-base,
          ebtables,
          iptables,
-         liblxc1 (>= 2.0.0~),
+         liblxc1 (>= 2.1.0~),
          lsb-base (>= 3.0-6),
          lxd-client (= ${binary:Version}),
          lxcfs,
@@ -45,6 +64,7 @@
          rsync,
          squashfs-tools,
          uidmap (>= 1:4.1.5.1-1ubuntu5~),
+         xdelta3,
          xz-utils,
          ${misc:Depends},
          ${shlibs:Depends}
@@ -68,7 +88,7 @@
  This is a dummy metapackage to install LXD and its client.
 
 Package: lxd-tools
-Architecture: any
+Architecture: amd64 arm64 armhf i386 ppc64el s390x
 Depends: ${misc:Depends}, ${shlibs:Depends}, python3, python3-lxc
 Built-Using: ${misc:Built-Using}
 Description: Container hypervisor based on LXC - extra tools

=== debian/rules ===
--- 
+++ 
@@ -6,13 +6,13 @@
 
 PKGDIR=debian/tmp
 VERSION=$(shell grep "var Version" $(CURDIR)/shared/version/flex.go | cut -d'"' -f2)
-DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
+include /usr/share/dpkg/default.mk
 
 # temporary build path (see http://golang.org/doc/code.html#GOPATH)
 export DH_GOPKG := github.com/lxc/lxd
 export GOPATH := $(CURDIR)/obj-$(DEB_BUILD_GNU_TYPE)
-export USE_EMBEDDED := true
-export USE_SHLIBS := false
+export USE_EMBEDDED := false
+export USE_SHLIBS := true
 
 ifeq ($(USE_SHLIBS), true)
 export DH_GOLANG_LINK_SHARED := 1
@@ -91,8 +91,8 @@
 	mkdir -p $(PKGDIR)/usr/share/man/man1/
 	help2man $(PKGDIR)/usr/bin/fuidshift -n "uid/gid shifter" --no-info > $(PKGDIR)/usr/share/man/man1/fuidshift.1
 	help2man $(PKGDIR)/usr/bin/lxc-to-lxd -n "Convert LXC containers to LXD" --no-info --version-string=$(VERSION) > $(PKGDIR)/usr/share/man/man1/lxc-to-lxd.1
-	help2man $(PKGDIR)/usr/bin/lxd -n "The container lightervisor - daemon" --no-info > $(PKGDIR)/usr/share/man/man1/lxd.1
-	help2man $(PKGDIR)/usr/bin/lxd-benchmark -n "The container lightervisor - benchmark" --no-info --version-string=$(VERSION) --no-discard-stderr > $(PKGDIR)/usr/share/man/man1/lxd-benchmark.1
+	help2man $(PKGDIR)/usr/bin/lxd -n "The container lightervisor - daemon" --no-info --no-discard-stderr > $(PKGDIR)/usr/share/man/man1/lxd.1
+	help2man $(PKGDIR)/usr/bin/lxd-benchmark -n "The container lightervisor - benchmark" --no-info --no-discard-stderr > $(PKGDIR)/usr/share/man/man1/lxd-benchmark.1
 	$(PKGDIR)/usr/bin/lxc manpage $(PKGDIR)/usr/share/man/man1/
 
 	# Install bash completion scripts
@@ -121,6 +121,16 @@
 	dh_install
 
 override_dh_installinit:
+ifeq (,$(findstring $(DEB_DISTRIBUTION), trusty xenial zesty))
+	# Disable upstart integration on artful+
+	rm -f debian/lxd.upstart
+	cp debian/lxd.maintscript.in debian/lxd.maintscript
+else
+	# Enable upstart integration for backports
+	cp debian/lxd.upstart.in debian/lxd.upstart
+	sed -i "s#@LIBEXECDIR@#/usr/lib/${DEB_HOST_MULTIARCH}#g" debian/lxd.upstart
+	grep -v /etc/init debian/lxd.maintscript.in > debian/lxd.maintscript
+endif
 	# We handle starting and restarting things ourselves
 	dh_systemd_enable -plxd --name=lxd-containers lxd-containers.service
 	dh_installinit -plxd --no-start
@@ -129,7 +139,6 @@
 
 	# Update arch-specific paths
 	sed -i "s#@LIBEXECDIR@#/usr/lib/${DEB_HOST_MULTIARCH}#g" debian/lxd/lib/systemd/system/lxd.service
-	sed -i "s#@LIBEXECDIR@#/usr/lib/${DEB_HOST_MULTIARCH}#g" debian/lxd/etc/init/lxd.conf
 	sed -i "s#@LIBEXECDIR@#/usr/lib/${DEB_HOST_MULTIARCH}#g" debian/lxd/etc/init.d/lxd
 
 override_dh_systemd_start:

## lxd 2.21

=== Makefile ===
--- 
+++ 
@@ -9,7 +9,7 @@
 # TODO: use git describe for versioning
 VERSION=$(shell grep "var Version" shared/version/flex.go | cut -d'"' -f2)
 ARCHIVE=lxd-$(VERSION).tar
-TAGS=$(shell test -e /usr/include/sqlite3.h && echo "-tags libsqlite3")
+TAGS=$(shell printf "\#include <sqlite3.h>\nvoid main(){}" | $(CC) -o /dev/null -xc - >/dev/null 2>&1 && echo "-tags libsqlite3")
 
 .PHONY: default
 default:

=== debian/changelog ===
lxd (2.21-0ubuntu2~17.04.1) zesty-backports; urgency=medium

  * Backport to Zesty.
  * Reduce liblxc dependency to >= 2.0.0~.
  * Build using Go 1.9 backport.

 -- Stéphane Graber <stgraber@ubuntu.com>  Fri, 22 Dec 2017 17:35:30 -0500

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: admin
 Priority: optional
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-Standards-Version: 4.1.0
+Standards-Version: 4.1.2
 Homepage: https://linuxcontainers.org/
 Vcs-Git: https://github.com/lxc/lxd-pkg-ubuntu
 Vcs-Browser: https://github.com/lxc/lxd-pkg-ubuntu
@@ -10,25 +10,7 @@
                dh-apparmor,
                dh-golang,
                debhelper (>= 9.20160709) | dh-systemd,
-               golang-go,
-               golang-any-shared-dev,
-               golang-go.crypto-dev,
-               golang-github-gorilla-context-dev,
-               golang-github-gorilla-mux-dev,
-               golang-github-gosexy-gettext-dev,
-               golang-github-mattn-go-colorable-dev,
-               golang-github-mattn-go-sqlite3-dev,
-               golang-github-olekukonko-tablewriter-dev,
-               golang-github-pborman-uuid-dev,
-               golang-gocapability-dev,
-               golang-gopkg-flosch-pongo2.v3-dev,
-               golang-gopkg-inconshreveable-log15.v2-dev,
-               golang-gopkg-lxc-go-lxc.v2-dev,
-               golang-gopkg-tomb.v2-dev,
-               golang-goprotobuf-dev,
-               golang-petname-dev,
-               golang-yaml.v2-dev,
-               golang-websocket-dev,
+               golang-1.9-go,
                help2man,
                libacl1-dev,
                libsqlite3-dev,
@@ -56,7 +38,7 @@
          dnsmasq-base,
          ebtables,
          iptables,
-         liblxc1 (>= 2.1.0~),
+         liblxc1 (>= 2.0.0~),
          lsb-base (>= 3.0-6),
          lxd-client (= ${binary:Version}),
          lxcfs,
@@ -79,7 +61,6 @@
 Package: lxc2
 Architecture: all
 Depends: lxd, lxd-client, ${misc:Depends}
-Priority: extra
 Section: metapackages
 Description: Container hypervisor based on LXC - metapackage
  LXD offers a REST API to remotely manage containers over the network,

=== debian/rules ===
--- 
+++ 
@@ -11,8 +11,11 @@
 # temporary build path (see http://golang.org/doc/code.html#GOPATH)
 export DH_GOPKG := github.com/lxc/lxd
 export GOPATH := $(CURDIR)/obj-$(DEB_BUILD_GNU_TYPE)
-export USE_EMBEDDED := false
-export USE_SHLIBS := true
+export USE_EMBEDDED := true
+export USE_SHLIBS := false
+
+# use golang-1.9
+export PATH := /usr/lib/go-1.9/bin:$(PATH)
 
 ifeq ($(USE_SHLIBS), true)
 export DH_GOLANG_LINK_SHARED := 1

## lxd 3.0.0

=== Makefile ===
--- 
+++ 
@@ -9,7 +9,7 @@
 # TODO: use git describe for versioning
 VERSION=$(shell grep "var Version" shared/version/flex.go | cut -d'"' -f2)
 ARCHIVE=lxd-$(VERSION).tar
-TAGS=$(shell printf "\#include <sqlite3.h>\nvoid main(){}" | $(CC) -o /dev/null -xc - >/dev/null 2>&1 && echo "-tags libsqlite3")
+TAGS=$(shell printf "\#include <sqlite3.h>\nvoid main(){int n = SQLITE_CONFIG_REPLICATION;}" | $(CC) -o /dev/null -xc - >/dev/null 2>&1 && echo "-tags libsqlite3")
 
 .PHONY: default
 default:
@@ -44,7 +44,7 @@
 # it's not a default build step.
 .PHONY: protobuf
 protobuf:
-	protoc --go_out=. ./lxd/migrate.proto
+	protoc --go_out=. ./lxd/migration/migrate.proto
 
 .PHONY: check
 check: default
@@ -72,8 +72,10 @@
 	# Download dependencies
 	cd $(TMP)/lxd-$(VERSION) && GOPATH=$(TMP)/dist go get -t -v -d ./...
 
-	# Workaround for gorilla/mux on Go < 1.7
-	cd $(TMP)/lxd-$(VERSION) && GOPATH=$(TMP)/dist go get -v -d github.com/gorilla/context
+	# Download the cluster-enabled sqlite
+	git clone https://github.com/CanonicalLtd/sqlite $(TMP)/dist/sqlite
+	cd $(TMP)/dist/sqlite && git log -1 --format="format:%ci%n" | sed -e 's/ [-+].*$$//;s/ /T/;s/^/D /' > manifest
+	cd $(TMP)/dist/sqlite && git log -1 --format="format:%H" > manifest.uuid
 
 	# Assemble tarball
 	rm $(TMP)/dist/src/github.com/lxc/lxd
@@ -101,7 +103,7 @@
 
 update-pot:
 	go get -v -x github.com/snapcore/snapd/i18n/xgettext-go/
-	xgettext-go -o po/$(DOMAIN).pot --add-comments-tag=TRANSLATORS: --sort-output --package-name=$(DOMAIN) --msgid-bugs-address=lxc-devel@lists.linuxcontainers.org --keyword=i18n.G --keyword-plural=i18n.NG shared/*.go lxc/*.go lxd/*.go
+	xgettext-go -o po/$(DOMAIN).pot --add-comments-tag=TRANSLATORS: --sort-output --package-name=$(DOMAIN) --msgid-bugs-address=lxc-devel@lists.linuxcontainers.org --keyword=i18n.G --keyword-plural=i18n.NG lxc/*.go lxc/*/*.go
 
 build-mo: $(MOFILES)

=== dist/src/google.golang.org/grpc/Makefile ===
all: test testrace

deps:
	go get -d -v google.golang.org/grpc/...

updatedeps:
	go get -d -v -u -f google.golang.org/grpc/...

testdeps:
	go get -d -v -t google.golang.org/grpc/...

updatetestdeps:
	go get -d -v -t -u -f google.golang.org/grpc/...

build: deps
	go build google.golang.org/grpc/...

proto:
	@ if ! which protoc > /dev/null; then \
		echo "error: protoc not installed" >&2; \
		exit 1; \
	fi
	go generate google.golang.org/grpc/...

test: testdeps
	go test -cpu 1,4 -timeout 5m google.golang.org/grpc/...

testrace: testdeps
	go test -race -cpu 1,4 -timeout 7m google.golang.org/grpc/...

clean:
	go clean -i google.golang.org/grpc/...

.PHONY: \
	all \
	deps \
	updatedeps \
	testdeps \
	updatetestdeps \
	build \
	proto \
	test \
	testrace \
	clean \
	coverage

=== dist/src/github.com/CanonicalLtd/dqlite/Makefile ===
proto:
	protoc --gofast_out=. internal/protocol/commands.proto

.PHONY: proto

=== dist/src/github.com/CanonicalLtd/go-grpc-sql/Makefile ===
proto:
	protoc --gofast_out=plugins=grpc:. internal/protocol/sql.proto

=== dist/src/github.com/cpuguy83/go-md2man/Makefile ===
check:
	gometalinter --config .gometalinter.json ./...

=== dist/src/github.com/juju/gomaasapi/Makefile ===
# Build, and run tests.
check: examples
	go test ./...

example_source := $(wildcard example/*.go)
example_binaries := $(patsubst %.go,%,$(example_source))

# Clean up binaries.
clean:
	$(RM) $(example_binaries)

# Reformat the source files to match our layout standards.
format:
	gofmt -w .

# Invoke gofmt's "simplify" option to streamline the source code.
simplify:
	gofmt -w -s .

# Build the examples (we have no tests for them).
examples: $(example_binaries)

%: %.go
	go build -o $@ $<

.PHONY: check clean format examples simplify

=== dist/src/gopkg.in/lxc/go-lxc.v2/Makefile ===
NO_COLOR=\033[0m
OK_COLOR=\033[0;32m

all: format vet lint

format:
	@echo "$(OK_COLOR)==> Formatting the code $(NO_COLOR)"
	@gofmt -s -w *.go
	@goimports -w *.go || true

test:
	@echo "$(OK_COLOR)==> Running go test $(NO_COLOR)"
	@sudo `which go` test -v

test-race:
	@echo "$(OK_COLOR)==> Running go test $(NO_COLOR)"
	@sudo `which go` test -race -v

test-unprivileged:
	@echo "$(OK_COLOR)==> Running go test for unprivileged user$(NO_COLOR)"
	@`which go` test -v

test-unprivileged-race:
	@echo "$(OK_COLOR)==> Running go test for unprivileged user$(NO_COLOR)"
	@`which go` test -race -v

cover:
	@sudo `which go` test -v -coverprofile=coverage.out
	@`which go` tool cover -func=coverage.out

doc:
	@`which godoc` gopkg.in/lxc/go-lxc.v2 | less

vet:
	@echo "$(OK_COLOR)==> Running go vet $(NO_COLOR)"
	@`which go` vet .

lint:
	@echo "$(OK_COLOR)==> Running golint $(NO_COLOR)"
	@`which golint` . || true

escape-analysis:
	@go build -gcflags -m

ctags:
	@ctags -R --languages=c,go

scope:
	@echo "$(OK_COLOR)==> Exported container calls in container.go $(NO_COLOR)"
	@/bin/grep -E "\bc+\.([A-Z])\w+" container.go || true

setup-test-cgroup:
	for d in /sys/fs/cgroup/*; do \
	    [ -f $$d/cgroup.clone_children ] && echo 1 | sudo tee $$d/cgroup.clone_children; \
	    [ -f $$d/cgroup.use_hierarchy ] && echo 1 | sudo tee $$d/cgroup.use_hierarchy; \
	    sudo mkdir -p $$d/lxc; \
	    sudo chown -R $$USER: $$d/lxc; \
	done

.PHONY: all format test doc vet lint ctags

=== dist/src/github.com/golang/protobuf/protoc-gen-go/descriptor/Makefile ===
# Go support for Protocol Buffers - Google's data interchange format
#
# Copyright 2010 The Go Authors.  All rights reserved.
# https://github.com/golang/protobuf
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
#     * Redistributions of source code must retain the above copyright
# notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above
# copyright notice, this list of conditions and the following disclaimer
# in the documentation and/or other materials provided with the
# distribution.
#     * Neither the name of Google Inc. nor the names of its
# contributors may be used to endorse or promote products derived from
# this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

# Not stored here, but descriptor.proto is in https://github.com/google/protobuf/
# at src/google/protobuf/descriptor.proto
regenerate:
	@echo WARNING! THIS RULE IS PROBABLY NOT RIGHT FOR YOUR INSTALLATION
	cp $(HOME)/src/protobuf/include/google/protobuf/descriptor.proto .
	protoc --go_out=../../../../.. -I$(HOME)/src/protobuf/include $(HOME)/src/protobuf/include/google/protobuf/descriptor.proto

=== dist/src/github.com/golang/protobuf/protoc-gen-go/plugin/Makefile ===
# Go support for Protocol Buffers - Google's data interchange format
#
# Copyright 2010 The Go Authors.  All rights reserved.
# https://github.com/golang/protobuf
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
#     * Redistributions of source code must retain the above copyright
# notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above
# copyright notice, this list of conditions and the following disclaimer
# in the documentation and/or other materials provided with the
# distribution.
#     * Neither the name of Google Inc. nor the names of its
# contributors may be used to endorse or promote products derived from
# this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

# Not stored here, but plugin.proto is in https://github.com/google/protobuf/
# at src/google/protobuf/compiler/plugin.proto
# Also we need to fix an import.
regenerate:
	@echo WARNING! THIS RULE IS PROBABLY NOT RIGHT FOR YOUR INSTALLATION
	cp $(HOME)/src/protobuf/include/google/protobuf/compiler/plugin.proto .
	protoc --go_out=Mgoogle/protobuf/descriptor.proto=github.com/golang/protobuf/protoc-gen-go/descriptor:../../../../.. \
		-I$(HOME)/src/protobuf/include $(HOME)/src/protobuf/include/google/protobuf/compiler/plugin.proto

restore:
	cp plugin.pb.golden plugin.pb.go

preserve:
	cp plugin.pb.go plugin.pb.golden

=== debian/control ===
--- 
+++ 
@@ -2,21 +2,21 @@
 Section: admin
 Priority: optional
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-Standards-Version: 4.1.2
+Standards-Version: 4.1.4
 Homepage: https://linuxcontainers.org/
 Vcs-Git: https://github.com/lxc/lxd-pkg-ubuntu
 Vcs-Browser: https://github.com/lxc/lxd-pkg-ubuntu
-Build-Depends: debhelper (>= 9),
+Build-Depends: debhelper (>= 10),
                dh-apparmor,
                dh-golang,
-               debhelper (>= 9.20160709) | dh-systemd,
-               golang-1.9-go,
+               golang-go,
                help2man,
                libacl1-dev,
-               libsqlite3-dev,
                lxc-dev (>= 1.1.0~),
                pkg-config,
-               python3-lxc
+               python3-lxc,
+               tcl8.6-dev
+XS-Go-Import-Path: github.com/lxc/lxd
 
 Package: lxd-client
 Architecture: amd64 arm64 armhf i386 ppc64el s390x
@@ -38,7 +38,7 @@
          dnsmasq-base,
          ebtables,
          iptables,
-         liblxc1 (>= 2.0.0~),
+         liblxc1 (>= 2.1.0~),
          lsb-base (>= 3.0-6),
          lxd-client (= ${binary:Version}),
          lxcfs,
@@ -58,16 +58,6 @@
  .
  This package contains the LXD daemon.
 
-Package: lxc2
-Architecture: all
-Depends: lxd, lxd-client, ${misc:Depends}
-Section: metapackages
-Description: Container hypervisor based on LXC - metapackage
- LXD offers a REST API to remotely manage containers over the network,
- using an image based workflow and with support for live migration.
- .
- This is a dummy metapackage to install LXD and its client.
-
 Package: lxd-tools
 Architecture: amd64 arm64 armhf i386 ppc64el s390x
 Depends: ${misc:Depends}, ${shlibs:Depends}, python3, python3-lxc
@@ -80,12 +70,3 @@
   - fuidshift - A tool to map/unmap filesystem uids/gids
   - lxc-to-lxd - A tool to migrate LXC containers to LXD
   - lxd-benchmark - A benchmarking tool for LXD
-
-Package: golang-github-lxc-lxd-dev
-Architecture: all
-Depends: golang-go, lxc-dev, pkg-config, ${misc:Depends}, ${shlibs:Depends}
-Description: Container hypervisor based on LXC - go source
- LXD offers a REST API to remotely manage containers over the network,
- using an image based workflow and with support for live migration.
- .
- This package contains the source tree of the lxd project.

=== debian/rules ===
--- 
+++ 
@@ -13,9 +13,8 @@
 export GOPATH := $(CURDIR)/obj-$(DEB_BUILD_GNU_TYPE)
 export USE_EMBEDDED := true
 export USE_SHLIBS := false
-
-# use golang-1.9
-export PATH := /usr/lib/go-1.9/bin:$(PATH)
+export CGO_LDFLAGS=-L$(CURDIR)/dist/sqlite/.libs/
+export CGO_CFLAGS=-I$(CURDIR)/dist/sqlite/
 
 ifeq ($(USE_SHLIBS), true)
 export DH_GOLANG_LINK_SHARED := 1
@@ -24,8 +23,11 @@
 %:
 	dh $@ --with systemd --buildsystem=golang --with=golang
 
-# Make sure we use the distro libsqlite3
 override_dh_auto_build:
+	# Build our own sqlite3
+	cd dist/sqlite && ./configure --enable-replication && make
+
+	# And then build using it
 	dh_auto_build -- -tags libsqlite3
 
 # Ugly workaround for bundled dependencies
@@ -94,13 +96,13 @@
 	mkdir -p $(PKGDIR)/usr/share/man/man1/
 	help2man $(PKGDIR)/usr/bin/fuidshift -n "uid/gid shifter" --no-info > $(PKGDIR)/usr/share/man/man1/fuidshift.1
 	help2man $(PKGDIR)/usr/bin/lxc-to-lxd -n "Convert LXC containers to LXD" --no-info --version-string=$(VERSION) > $(PKGDIR)/usr/share/man/man1/lxc-to-lxd.1
-	help2man $(PKGDIR)/usr/bin/lxd -n "The container lightervisor - daemon" --no-info --no-discard-stderr > $(PKGDIR)/usr/share/man/man1/lxd.1
 	help2man $(PKGDIR)/usr/bin/lxd-benchmark -n "The container lightervisor - benchmark" --no-info --no-discard-stderr > $(PKGDIR)/usr/share/man/man1/lxd-benchmark.1
+	$(PKGDIR)/usr/bin/lxd manpage $(PKGDIR)/usr/share/man/man1/
 	$(PKGDIR)/usr/bin/lxc manpage $(PKGDIR)/usr/share/man/man1/
 
 	# Install bash completion scripts
 	mkdir -p $(PKGDIR)/usr/share/bash-completion/completions/
-	cp config/bash/lxd-client $(PKGDIR)/usr/share/bash-completion/completions/lxc
+	cp scripts/bash/lxd-client $(PKGDIR)/usr/share/bash-completion/completions/lxc
 
 	# Prepare dev package
 	rm -Rf $(PKGDIR)/usr/share/gocode/src/github.com/lxc/
@@ -120,6 +122,14 @@
 	mkdir -p $(PKGDIR)/etc/sysctl.d
 	cp debian/lxd.sysctl $(PKGDIR)/etc/sysctl.d/10-lxd-inotify.conf
 
+	# Include wrappers and sqlite3 library
+	mkdir -p $(PKGDIR)/usr/lib/lxd/
+	mv $(PKGDIR)/usr/bin/lxd $(PKGDIR)/usr/lib/lxd/
+	cp debian/wrappers/lxd $(PKGDIR)/usr/bin/
+	cp debian/wrappers/shutdown $(PKGDIR)/usr/lib/lxd/
+	cp debian/wrappers/upgrade-bridge $(PKGDIR)/usr/lib/lxd/
+	cp dist/sqlite/.libs/libsqlite3.so.0* $(PKGDIR)/usr/lib/lxd/
+
 	# Trigger normal dh_install
 	dh_install
 
@@ -138,7 +148,7 @@
 	dh_systemd_enable -plxd --name=lxd-containers lxd-containers.service
 	dh_installinit -plxd --no-start
 	dh_installinit -plxd --name=lxd-containers --no-start --noscripts
-	dh_systemd_start -plxd lxd-containers.service --no-restart-on-upgrade
+	dh_systemd_start -plxd lxd-containers.service --no-restart-on-upgrade --no-restart-after-upgrade
 
 	# Update arch-specific paths
 	sed -i "s#@LIBEXECDIR@#/usr/lib/${DEB_HOST_MULTIARCH}#g" debian/lxd/lib/systemd/system/lxd.service

=== debian/tests/control ===
Tests: exercise
Depends: acl,
         busybox-static,
         btrfs-tools,
         curl,
         flake8,
         golang-go,
         jq,
         git,
         gettext,
         make,
         pep8,
         pyflakes3,
         shellcheck,
         sqlite3,
         thin-provisioning-tools,
         uuid-runtime,
         zfsutils-linux [amd64 arm64 ppc64el s390x],
         @builddeps@,
         @
Restrictions: needs-root allow-stderr isolation-machine
